<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'SlpColumn',
  props: {
    cols: {
      type: Number,
      required: false,
      default: null,
    },
    size: {
      type: String,
      required: false,
      default: 'md',
    },
  },
  computed: {
    className(): string {
      if (this.cols) {
        return `slp-col-${this.size}-${this.cols}`;
      }
      return `slp-col-${this.size}`;
    },
  },
});
</script>

<template>
  <div :class="className">
    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
@use 'sass:math';
@for $cols from 1 through $max-columns {
  @each $name, $size in $breakpoints {
    @media (max-width: $size) {
      .#{$prefix}-col-#{$name},
      .#{$prefix}-col-#{$name}-#{$cols} {
        width: inherit;
        max-width: 100%;
      }
    }
    @media (min-width: $size) {
      .#{$prefix}-col-#{$name}-#{$cols} {
        position: relative;
        width: 100%;
        min-height: 1px;
        flex: 0 0 percentage(math.div($cols, $max-columns));
        max-width: percentage(math.div($cols, $max-columns));
      }

      .#{$prefix}-col-#{$name} {
        flex-basis: 0;
        flex-grow: 1;
        position: relative;
        width: 100%;
        min-height: 1px;
        max-width: 100%;
      }
    }
  }
}
</style>
